package
{
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import gallery.GalleryManager;
	import gallery.ImageItem;
	import gallery.TransitionObject;
	
	import tools.Statics;
	
	import transitions.TransitionManager;
	
	[SWF(width='400', height='400', frameRate='60')]
	public class Gallery extends Sprite
	{
		public function Gallery()
		{
			if(stage) init(null);
			else      this.addEventListener(Event.ADDED_TO_STAGE,init);
		}
		private function init(e:Event):void
		{
			if(e!=null) this.removeEventListener(Event.ADDED_TO_STAGE,init);
			
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			var settingsXMLLoader:URLLoader = new URLLoader();
			settingsXMLLoader.addEventListener(Event.COMPLETE,settingsLoaded);
			settingsXMLLoader.load(new URLRequest("test.xml"));
		}
		private function settingsLoaded(e:Event):void
		{
			e.currentTarget.removeEventListener(Event.COMPLETE,settingsLoaded);
			var settingsXML:XML = new XML(e.currentTarget.data);
			
			Statics.stageWidth = stage.stageWidth;
			Statics.stageHeight = stage.stageHeight;
			
			Statics.itemAreaWidth = (settingsXML.settings[0].itemArea.@width == undefined) ? 400 :  settingsXML.settings[0].itemArea.@width;
			Statics.itemAreaHeight = (settingsXML.settings[0].itemArea.@height == undefined) ? 300 :  settingsXML.settings[0].itemArea.@height;
			Statics.transition = toTransitionObject(settingsXML.settings[0].transition);
			Statics.slideShowTime = (settingsXML.settings[0].slideShow.@time == undefined) ? 4 :  settingsXML.settings[0].slideShow.@time;
			
			var itemsPath:Array = new Array(settingsXML.items[0].item.length());
			var thumbsPath:Array = new Array(settingsXML.items[0].item.length());
			var itemTransitions:Array = new Array(settingsXML.items[0].item.length());
			
			for(var i:int = 0;i<itemsPath.length;i++){
				itemTransitions[i] = toTransitionObject(settingsXML.items[0].item[i].transition);
				itemsPath[i] =  (settingsXML.items[0].item[i].itemPath == undefined) ? "undefined" :  settingsXML.items[0].item[i].itemPath.toString();
				thumbsPath[i] = (settingsXML.items[0].item[i].thumbPath == undefined) ? "undefined" :  settingsXML.items[0].item[i].thumbPath.toString();
			}
			addChild(new GalleryManager(itemsPath,thumbsPath,itemTransitions));
		}
		private function toTransitionObject(transitionXML:XMLList):TransitionObject{
			if(transitionXML.@type == undefined){
				return null;
			}
			var transitionObject:TransitionObject = new TransitionObject();
			transitionObject.type = (transitionXML.@type == undefined) ? TransitionManager.NONE :  transitionXML.@type;
			transitionObject.direction = (transitionXML.@direction == undefined) ? null :  transitionXML.@direction;
			transitionObject.subtype = (transitionXML.@subtype == undefined) ? null :  transitionXML.@subtype;
			transitionObject.shapeURL = (transitionXML.@shapeURL == undefined) ? null :  transitionXML.@shapeURL;
			
			transitionObject.time = (transitionXML.@time == undefined) ? NaN :  transitionXML.@time;
			transitionObject.amount = (transitionXML.@amount == undefined) ? NaN :  transitionXML.@amount;
			transitionObject.effect = (transitionXML.@effect == undefined) ? NaN :  transitionXML.@effect;
			transitionObject.startAlpha = (transitionXML.@startAlpha == undefined) ? NaN :  transitionXML.@startAlpha;
			
			transitionObject.multiplier= (transitionXML.@multiplier == undefined) ? NaN :  transitionXML.@multiplier;
			transitionObject.rotate= (transitionXML.@rotate == undefined) ? NaN :  transitionXML.@rotate;
			transitionObject.color= (transitionXML.@color == undefined) ? NaN :  transitionXML.@color;
			transitionObject.delay= (transitionXML.@delay == undefined) ? NaN :  transitionXML.@delay;
			transitionObject.size= (transitionXML.@size == undefined) ? NaN :  transitionXML.@size;
			transitionObject.rowAmount= (transitionXML.@rowAmount == undefined) ? NaN :  transitionXML.@rowAmount;
			transitionObject.colAmount= (transitionXML.@colAmount == undefined) ? NaN :  transitionXML.@colAmount;
			transitionObject.velocityXMin= (transitionXML.@velocityXMin == undefined) ? NaN :  transitionXML.@velocityXMin;
			transitionObject.velocityYMin= (transitionXML.@velocityYMin == undefined) ? NaN :  transitionXML.@velocityYMin;
			transitionObject.velocityXMax= (transitionXML.@velocityXMax == undefined) ? NaN :  transitionXML.@velocityXMax;
			transitionObject.velocityYMax= (transitionXML.@velocityYMax == undefined) ? NaN :  transitionXML.@velocityYMax;
			transitionObject.gravity= (transitionXML.@gravity == undefined) ? NaN :  transitionXML.@gravity;
			transitionObject.smooth= (transitionXML.@smooth == undefined) ? NaN :  transitionXML.@smooth;
			transitionObject.blurX= (transitionXML.@blurX == undefined) ? NaN :  transitionXML.@blurX;
			transitionObject.blurY= (transitionXML.@blurY == undefined) ? NaN :  transitionXML.@blurY;
			transitionObject.quality= (transitionXML.@quality == undefined) ? NaN :  transitionXML.@quality;
			return transitionObject;
		}
	}
}