package thumbAreas
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	
	import tools.Statics;
	
	
	public class SimpleLinearThumbArea extends Sprite
	{
		public static const Thumbs_Loaded:String = "ThumbsLoaded"; 
		
		private var thumbsPath:Array;
		private var thumbSpriteWidth:Number;
		private var thumbSpriteHeight:Number;
		private var thumbWidth:Number;
		private var thumbHeight:Number;
		private var orientation:String;
		private var position:String;
		private var thumbAlpha:Number;
		private var thumbmoverAlpha:Number;
		private var borderColor:uint;
		private var borderAlpha:Number;
		private var thumbsSprite:Sprite;
		private var thumbSpace:Number;
		private var nextArrow:Sprite;
		private var previousArrow:Sprite;
		private var slideAmount:Number;
		private var currentThumb:Number = 0;
		public function SimpleLinearThumbArea(thumbSettings:ThumbAreaSettings,thumbsPath:Array)
		{
			super();
			this.thumbsPath = thumbsPath;
			
			orientation = (thumbSettings.orientation != null) ? thumbSettings.orientation : ThumbAreaSettings.HORIZONTAL;
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				position = (thumbSettings.position != null) ? thumbSettings.position : ThumbAreaSettings.RIGHT;
			}else{
				position = (thumbSettings.position != null) ? thumbSettings.position : ThumbAreaSettings.BOTTOM;
			}
			thumbWidth = isNaN(thumbSettings.thumbWidth) ? 80 : thumbSettings.thumbWidth;
			thumbHeight = isNaN(thumbSettings.thumbHeight) ? 80 : thumbSettings.thumbHeight;
			
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				thumbSpriteWidth = thumbWidth + 10;
				thumbSpriteHeight = Statics.stageHeight;
				var thumbCount:Number = Math.floor((thumbSpriteHeight - 30) / thumbHeight);
				thumbSpace = (thumbSpriteHeight - 30 - thumbCount * thumbHeight) / thumbCount ;
				if(thumbSpace<10){
					thumbCount--;
					thumbSpace = (thumbSpriteHeight - 30 - thumbCount * thumbHeight) / thumbCount ;
				}
				slideAmount = thumbCount * (thumbHeight + thumbSpace);
			}else{
				thumbSpriteWidth = Statics.stageWidth;
				thumbSpriteHeight = thumbHeight + 10;
				thumbCount = Math.floor((thumbSpriteWidth - 30) / thumbWidth);
				thumbSpace = (thumbSpriteWidth - 30 - thumbCount * thumbWidth) / thumbCount ;
				if(thumbSpace<10){
					thumbCount--;
					thumbSpace = (thumbSpriteWidth - 30 - thumbCount * thumbWidth) / thumbCount ;
				}
				slideAmount = thumbCount * (thumbWidth + thumbSpace);
			}
			
			
			if(position == ThumbAreaSettings.BOTTOM){
				this.x = 0;
				this.y = Statics.stageHeight - thumbSpriteHeight;
			}else if(position == ThumbAreaSettings.TOP){
				this.x = 0;
				this.y = 0;
			}else if(position == ThumbAreaSettings.RIGHT){
				this.x = Statics.stageWidth - thumbSpriteWidth;
				this.y = 0;
			}else if(position == ThumbAreaSettings.LEFT){
				this.x = 0;
				this.y = 0;
			}
			
			var bg:Shape = new Shape();
			var bgColor:uint = (thumbSettings.bgColor == 0xFFFFFFFF) ? 0x000000 : thumbSettings.bgColor;
			var bgAlpha:Number = isNaN(thumbSettings.bgAlpha) ? 1 : thumbSettings.bgAlpha;
			bg.graphics.beginFill(bgColor, bgAlpha);
			bg.graphics.drawRect( 0, 0, thumbSpriteWidth, thumbSpriteHeight);
			bg.graphics.endFill();
			addChild(bg);
			
			thumbAlpha = isNaN(thumbSettings.thumbAlpha) ? 0.2 : thumbSettings.thumbAlpha;
			thumbmoverAlpha = isNaN(thumbSettings.thumbmoverAlpha) ? 1 : thumbSettings.thumbmoverAlpha;
			borderColor = (thumbSettings.borderColor == 0xFFFFFFFF) ? 0xFFFFFF : thumbSettings.borderColor;
			borderAlpha = isNaN(thumbSettings.borderAlpha) ? 1 : thumbSettings.borderAlpha;
			
			var mask:Shape = new Shape();
			if(orientation == ThumbAreaSettings.HORIZONTAL){
				var mwidth:Number = thumbSpriteWidth-30;
				var mheight:Number = thumbHeight;
				var mx:Number = 15;
				var my:Number = (thumbSpriteHeight - thumbHeight) / 2;
			}else{
				mwidth = thumbWidth;
				mheight = thumbSpriteHeight-30;
				mx = (thumbSpriteWidth - thumbWidth) / 2;
				my = 15;
			}
			
			mask.graphics.beginFill(0x000000);
			mask.graphics.drawRect( 0, 0, mwidth , mheight);
			mask.graphics.endFill();
			mask.x = mx;
			mask.y = my;
			addChild(mask);
			
			thumbsSprite = new Sprite();
			thumbsSprite.mouseChildren = true;
			thumbsSprite.x = mx;
			thumbsSprite.y = my;
			addChild(thumbsSprite);
			thumbsSprite.mask = mask;
			
			var arrowColor:uint = (thumbSettings.arrowColor == 0xFFFFFFFF) ? 0xFFFFFF : thumbSettings.arrowColor;
			var arrowAlpha:uint =  isNaN(thumbSettings.arrowAlpha) ? 1 : thumbSettings.arrowAlpha;
			
			nextArrow = new Sprite();
			nextArrow.graphics.beginFill(0x000000,0);
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				nextArrow.graphics.drawRect(0,0,thumbSpriteWidth,15);
			}else{
				nextArrow.graphics.drawRect(0,0,15,thumbSpriteHeight);
			}
			nextArrow.graphics.endFill();
			nextArrow.graphics.lineStyle(3,arrowColor,arrowAlpha);
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				var arrowX:Number = nextArrow.width / 4;
				var arrowY:Number = nextArrow.height / 3;
				nextArrow.graphics.moveTo(arrowX,arrowY);
				nextArrow.graphics.lineTo(2 * arrowX,2 * arrowY);
				nextArrow.graphics.lineTo(3 * arrowX,arrowY);
				nextArrow.y = thumbSpriteHeight - nextArrow.height ;
			}else{
				arrowX = nextArrow.width / 3;
				arrowY = nextArrow.height / 4;
				nextArrow.graphics.moveTo(arrowX,arrowY);
				nextArrow.graphics.lineTo(2 * arrowX,2 * arrowY);
				nextArrow.graphics.lineTo(arrowX,3 * arrowY);
				nextArrow.x = thumbSpriteWidth - nextArrow.width;
			}
			nextArrow.alpha = 0.4;
			addChild(nextArrow);
			
			previousArrow = new Sprite();
			previousArrow.graphics.beginFill(0x000000,0);
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				previousArrow.graphics.drawRect(0,0,thumbSpriteWidth,15);
			}else{
				previousArrow.graphics.drawRect(0,0,15,thumbSpriteHeight);
			}
			previousArrow.graphics.endFill();
			previousArrow.graphics.lineStyle(3,arrowColor,arrowAlpha);
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				arrowX = previousArrow.width / 4;
				arrowY = previousArrow.height / 3;
				previousArrow.graphics.moveTo(arrowX,2 * arrowY);
				previousArrow.graphics.lineTo(2 * arrowX,arrowY);
				previousArrow.graphics.lineTo(3 * arrowX,2 * arrowY);
			}else{
				arrowX = previousArrow.width / 3;
				arrowY = previousArrow.height / 4;
				previousArrow.graphics.moveTo(2*arrowX,arrowY);
				previousArrow.graphics.lineTo(arrowX,2 * arrowY);
				previousArrow.graphics.lineTo(2*arrowX,3 * arrowY);
			}
			previousArrow.alpha = 0.4;
			addChild(previousArrow);
			
			nextArrow.buttonMode = true;
			previousArrow.buttonMode = true;
			
			nextArrow.addEventListener(MouseEvent.MOUSE_OVER,nextArrowOver);
			previousArrow.addEventListener(MouseEvent.MOUSE_OVER,previousArrowOver);
			nextArrow.addEventListener(MouseEvent.MOUSE_OUT,nextArrowOut);
			previousArrow.addEventListener(MouseEvent.MOUSE_OUT,previousArrowOut);
			nextArrow.addEventListener(MouseEvent.MOUSE_DOWN,nextArrowDown);
			previousArrow.addEventListener(MouseEvent.MOUSE_DOWN,previousArrowDown);
			
			
		}
		private function nextArrowOver(e:Event):void{
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				if(thumbsSprite.y + thumbsSprite.height - slideAmount > thumbsSprite.mask.y){
					Tweener.addTween(nextArrow,{alpha:1,time:0.2,transition:"linear"});
				}
			}else{
				if(thumbsSprite.x + thumbsSprite.width - slideAmount > thumbsSprite.mask.x){
					Tweener.addTween(nextArrow,{alpha:1,time:0.2,transition:"linear"});
				}
			}
		}
		private function previousArrowOver(e:Event):void{
			if(this.orientation == ThumbAreaSettings.VERTICAL){
				if(thumbsSprite.y +  slideAmount <= thumbsSprite.mask.y){
					Tweener.addTween(previousArrow,{alpha:1,time:0.2,transition:"linear"});
				}
			}else{
				if(thumbsSprite.x +  slideAmount <= thumbsSprite.mask.x){
					Tweener.addTween(previousArrow,{alpha:1,time:0.2,transition:"linear"});
				}
			}
		}
		private function nextArrowOut(e:Event):void{
			Tweener.addTween(nextArrow,{alpha:0.4,time:0.2,transition:"linear"});
		}
		private function previousArrowOut(e:Event):void{
			Tweener.addTween(previousArrow,{alpha:0.4,time:0.2,transition:"linear"});
		}
		private function nextArrowDown(e:Event):void{
			if(!Tweener.isTweening(thumbsSprite)){
				if(this.orientation == ThumbAreaSettings.VERTICAL){
					if(thumbsSprite.y + thumbsSprite.height - slideAmount > thumbsSprite.mask.y){
						Tweener.addTween(thumbsSprite,{y:thumbsSprite.y - slideAmount,time:1,transition:"easeOutCubic"});
					}
				}else{
					if(thumbsSprite.x + thumbsSprite.width - slideAmount > thumbsSprite.mask.x){
						Tweener.addTween(thumbsSprite,{x:thumbsSprite.x - slideAmount,time:1,transition:"easeOutCubic"});
					}
				}
			}
		}
		private function previousArrowDown(e:Event):void{
			if(!Tweener.isTweening(thumbsSprite)){
				if(this.orientation == ThumbAreaSettings.VERTICAL){
					if(thumbsSprite.y +  slideAmount <= thumbsSprite.mask.y){
						Tweener.addTween(thumbsSprite,{y:thumbsSprite.y + slideAmount,time:1,transition:"easeOutCubic"});
					}
				}else{
					if(thumbsSprite.x +  slideAmount <= thumbsSprite.mask.x){
						Tweener.addTween(thumbsSprite,{x:thumbsSprite.x + slideAmount,time:1,transition:"easeOutCubic"});
					}
				}
			}
		}
		public function load():void{
			loadThumb(0);
		}
		private function loadThumb(ind:Number):void{
			if (ind < thumbsPath.length) {
				var thumbLoader:Loader = new Loader();
				thumbLoader.name = "loader" + ind;
				thumbLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, thumbLoaded);
				thumbLoader.load(new URLRequest(thumbsPath[ind]));
			}else{
				dispatchEvent(new Event(Thumbs_Loaded));
				setcurrentThumb(0);
			}
		}
		private function thumbLoaded(e:Event):void {
			var thumbLoader:Loader = e.currentTarget.loader;
			var ind:Number = parseInt(thumbLoader.name.substring(6, thumbLoader.name.length));
			
			var hitArea:Sprite = new Sprite();
			hitArea.name = "hitArea" + ind;
			hitArea.graphics.lineStyle(1, borderColor, borderAlpha);
			hitArea.graphics.beginFill(0, 0);
			hitArea.graphics.drawRect(0, 0, thumbWidth - 1, thumbHeight - 1);
			hitArea.graphics.endFill();
			hitArea.buttonMode = true;
			
			if (orientation == ThumbAreaSettings.HORIZONTAL) {
				hitArea.x = ind * (thumbWidth + thumbSpace) + thumbSpace / 2;
				hitArea.y = 0;
			}
			else {
				hitArea.x = 0;
				hitArea.y = ind * (thumbHeight + thumbSpace) + thumbSpace / 2;
			}
			
			var sc:Number = Math.max(thumbWidth / thumbLoader.width, thumbHeight / thumbLoader.height);
			thumbLoader.scaleX = thumbLoader.scaleY = sc;
			thumbLoader.x = (Math.min(thumbWidth,thumbLoader.width) - thumbLoader.width) / 2;
			thumbLoader.y = (Math.min(thumbHeight,thumbLoader.height) - thumbLoader.height) / 2;
			var thumb:Sprite = new Sprite();
			thumb.addChild(thumbLoader);
			
			var mask:Shape = new Shape();
			mask.graphics.beginFill(0, 0);
			mask.graphics.drawRect(0, 0, thumbWidth, thumbHeight);
			mask.graphics.endFill();
			thumb.addChild(mask);
			thumb.mask =  mask;
			
			/*var sc:Number = Math.max(thumbWidth / thumbLoader.width, thumbHeight / thumbLoader.height);
			thumbLoader.scaleX = thumbLoader.scaleY = sc;
			var imBD:BitmapData = new BitmapData(Math.min(thumbWidth,thumbLoader.width), Math.min(thumbHeight,thumbLoader.height));
			var tMatrix:Matrix = new Matrix();
			tMatrix.scale(sc, sc)
			tMatrix.translate((Math.min(thumbWidth,thumbLoader.width) - thumbLoader.width) / 2, (Math.min(thumbHeight,thumbLoader.height) - thumbLoader.height) / 2);
			imBD.draw(thumbLoader, tMatrix);
			var thumb:Bitmap = new Bitmap(imBD);
			thumb.smoothing = true;*/
			thumb.name = "thumb" + ind;
			
			thumb.x = hitArea.x ;
			thumb.y = hitArea.y ;
			thumb.alpha = 1;
			thumb.alpha = thumbAlpha;
			
			hitArea.addEventListener(MouseEvent.MOUSE_OVER,thumbOver);
			hitArea.addEventListener(MouseEvent.MOUSE_OUT,thumbOut);
			hitArea.addEventListener(MouseEvent.MOUSE_DOWN,thumbDown);
			
			thumbsSprite.addChild(thumb);
			thumbsSprite.addChild(hitArea);
			
			//thumbLoader.unload();
			loadThumb(ind + 1);
		}
		
		private function thumbOver(e:Event):void{
			var hitArea:Sprite = Sprite(e.currentTarget);
			var ind:Number = parseInt(hitArea.name.substring(7, hitArea.name.length));
			var thumb:DisplayObject = thumbsSprite.getChildByName("thumb" + ind);
			Tweener.addTween(thumb, { alpha:1, time:1 } );
		}
		private function thumbOut(e:Event):void{
			var hitArea:Sprite = Sprite(e.currentTarget);
			var ind:Number = parseInt(hitArea.name.substring(7, hitArea.name.length));
			if(currentThumb != ind){
				var thumb:DisplayObject = thumbsSprite.getChildByName("thumb" + ind);
				Tweener.addTween(thumb, { alpha:thumbAlpha, time:1 } );
			}
		}
		private function thumbDown(e:Event):void{
			var hitArea:Sprite = Sprite(e.currentTarget);
			var ind:Number = parseInt(hitArea.name.substring(7, hitArea.name.length));
			setcurrentThumb(ind);
			dispatchEvent(new ThumbEvent(ThumbEvent.Thumb_Clicked, ind));
		}
		public function setcurrentThumb(ind:Number):void{
			if(ind>=0&&ind<thumbsPath.length){
				if(currentThumb>=0&&currentThumb<thumbsPath.length){
					var thumb:DisplayObject = thumbsSprite.getChildByName("thumb" + currentThumb);
					Tweener.addTween(thumb, { alpha:thumbAlpha, time:1 } );
				}
				thumb = thumbsSprite.getChildByName("thumb" + ind);
				Tweener.addTween(thumb, { alpha:1, time:1 } );
				currentThumb = ind;
			}
		}
		public function getRemainingBox():Rectangle {
			if (position == ThumbAreaSettings.TOP) {
				return new Rectangle(0, this.height, Statics.stageWidth, Statics.stageHeight - this.height);
			}
			else if (position == ThumbAreaSettings.BOTTOM) {
				return new Rectangle(0, 0, Statics.stageWidth, Statics.stageHeight - this.height);
			}
			else if (position == ThumbAreaSettings.LEFT) {
				return new Rectangle(this.width, 0, Statics.stageWidth - this.width, Statics.stageHeight);
			}
			else if (position == ThumbAreaSettings.RIGHT) {
				return new Rectangle(0, 0, Statics.stageWidth - this.width, Statics.stageHeight);
			}
			return new Rectangle(0, 0, Statics.stageWidth, Statics.stageHeight);
		}
		
	}
}