﻿package transitions 
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Matrix;

	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class CircleTransition extends Transition  
	{
		private var tweenObj:Object;
		private var current:Sprite;
		private var old:Sprite;
		public function CircleTransition(current:Sprite,old:Sprite,effect:Number=0,time:Number=1,startAlpha:Number=1) 
		{
			this.current = current;
			this.old = old;
			
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);	
				
			var mask:Shape = new Shape();
			mask.graphics.lineStyle(0, 0, 0);
			
			var radius:Number = Math.sqrt(TransitionManager.transitionAreaWidth * TransitionManager.transitionAreaWidth + 
										TransitionManager.transitionAreaHeight * TransitionManager.transitionAreaHeight) / 2;
			if(effect==1){
				var matrix:Matrix = new Matrix();
				matrix.createGradientBox(radius * 2, radius * 2,0, -radius, -radius);
			
				mask.graphics.beginGradientFill(GradientType.RADIAL, [0x000000, 0x000000], [1, 0], [200, 255], matrix);
			}else {
				mask.graphics.beginFill(0x000000, 1);
			}
			mask.graphics.drawCircle( 0, 0, radius);
			mask.graphics.endFill();
			mask.cacheAsBitmap = true;

			
			mask.x = TransitionManager.transitionAreaWidth/2;
			mask.y = TransitionManager.transitionAreaHeight/2;
			current.addChild(mask);
			current.alpha = startAlpha;
			current.mask = mask;
			
			mask.scaleX = mask.scaleY = 0;
			Tweener.addTween(mask, { scaleX:1.2, scaleY:1.2, time:time, transition:"linear", onComplete:transitionCompleted } );
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear" });
			
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			Tweener.removeTweens(current.mask);
			transitionCompleted();
		}
		
	}
	
}