package transitions
{
	
	import caurina.transitions.Tweener;
	
	import flash.display.Shader;
	import flash.display.Sprite;
	import flash.filters.ShaderFilter;
	import flash.utils.ByteArray;

	public class ContrastTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var shader:Shader;
		private var shaderFilter:ShaderFilter;
		private var contrastObject:Object;
		private var currentShader:Sprite;
		private var amount:Number;
		private var time:Number;
		public function ContrastTransition(current:Sprite,old:Sprite,amount:Number,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			this.amount = amount;
			this.time = time;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			current.visible = false;
			shader = new Shader(new TransitionManager.contrastFilter() as ByteArray);
			shaderFilter = new ShaderFilter(shader);
			contrastObject = new Object();
			contrastObject.contrast =  1;
			currentShader = old;
			Tweener.addTween(contrastObject,{contrast:amount, time:time/2, transition:"easeInQuad",onUpdate:render, onComplete:renderOutCompleted } );
		}
		private function render():void{
			shader.data.contrast.value = [contrastObject.contrast];
			currentShader.filters = [shaderFilter];
		}
		private function renderOutCompleted():void{
			current.visible = true;
			currentShader = current;
			Tweener.addTween(contrastObject,{contrast:1, time:time/2, transition:"easeOutQuad",onUpdate:render, onComplete:transitionCompleted } );
		}
		private function transitionCompleted():void {
			current.filters = [];
			if (old) {
				old.filters = [];
				old.visible = false;
			}
			current.visible = true;
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(contrastObject);
			current.alpha = 1;
			transitionCompleted();
		}
	}
}