package transitions
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;

	public class FanTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var subType:String;
		private var tweenObj:Object;
		private var amount:Number;
		private var bitmapData:BitmapData;
		public function FanTransition(current:Sprite,old:Sprite,subType:String = "1",amount:Number = 1,time:Number=1) 
		{
			
			this.current = current;
			this.old = old;
			this.subType = subType;
			this.amount = amount;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			
			tweenObj = new Object();
			tweenObj.angle = 0;
			tweenObj.count = 1;
			if(subType == "7"){
				bitmapData = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight,true,0x00000000);
				bitmapData.draw(current);
				var bd1:BitmapData = new BitmapData(TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight);
				bd1.copyPixels(bitmapData, new Rectangle(0, 0, TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight), new Point(0, 0));
				var grid1:Bitmap = new Bitmap(bd1);
				grid1.name = "grid1";
				var bd2:BitmapData = new BitmapData(TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight);
				bd2.copyPixels(bitmapData, new Rectangle(TransitionManager.transitionAreaWidth/2, 0, TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight), new Point(0, 0));
				var grid2:Bitmap = new Bitmap(bd2);
				grid2.name = "grid2";
				grid2.x = TransitionManager.transitionAreaWidth/2;
				
				var curMask1:Shape = new Shape();
				curMask1.cacheAsBitmap = true;
				current.parent.addChild(curMask1);
				grid1.mask = curMask1;
				
				var curMask2:Shape = new Shape();
				curMask2.cacheAsBitmap = true;
				current.parent.addChild(curMask2);
				grid2.mask = curMask2;
				
				current.parent.addChild(grid1);
				current.parent.addChild(grid2);
				
				current.visible = false;
				
				
				radius = Math.sqrt(TransitionManager.transitionAreaWidth / 2 * TransitionManager.transitionAreaWidth /2 + 
					TransitionManager.transitionAreaHeight/2 * TransitionManager.transitionAreaHeight/2) ;
				Tweener.addTween(tweenObj,{angle:2*Math.PI,onUpdate:updateMask,onComplete:transitionCompleted,time:time,transition:"linear",onUpdateParams:[radius]});
				
			}else{
				var curMask:Shape = new Shape();
				curMask.cacheAsBitmap = true;
				current.addChild(curMask);
				current.mask = curMask;
				if(subType == "1" || subType == "2"){
					var radius:Number = Math.sqrt(TransitionManager.transitionAreaWidth * TransitionManager.transitionAreaWidth + 
						TransitionManager.transitionAreaHeight * TransitionManager.transitionAreaHeight) / 2;
					Tweener.addTween(tweenObj,{angle:amount*2*Math.PI,onUpdate:updateMask,onComplete:transitionCompleted,time:time,transition:"linear",onUpdateParams:[radius]});
					
				}else if(subType == "3" || subType == "4"){
					radius = Math.sqrt(TransitionManager.transitionAreaWidth / 2 * TransitionManager.transitionAreaWidth /2 + 
						TransitionManager.transitionAreaHeight * TransitionManager.transitionAreaHeight) ;
					Tweener.addTween(tweenObj,{angle:amount*Math.PI/2,onUpdate:updateMask,onComplete:transitionCompleted,time:time,transition:"linear",onUpdateParams:[radius]});
					
				}else if(subType == "5" || subType == "6"){
					radius = Math.sqrt(TransitionManager.transitionAreaWidth * TransitionManager.transitionAreaWidth + 
						TransitionManager.transitionAreaHeight/2 * TransitionManager.transitionAreaHeight/2) ;
					Tweener.addTween(tweenObj,{angle:amount*Math.PI/2,onUpdate:updateMask,onComplete:transitionCompleted,time:time,transition:"linear",onUpdateParams:[radius]});
					
				}
			}
			
		}
		
		public function draw_arc(s:Shape,center_x:Number,center_y:Number,radius:Number,startAngle:Number,arcAngle:Number):void {
		
			var steps:Number = Math.max(5,Math.abs(Math.round((arcAngle / (2 * Math.PI)) * 80)));
			var angleStep:Number = arcAngle / steps;
			s.graphics.moveTo(center_x,center_y);
			for (var i:int=0; i<=steps; i++) {
				var angle:Number = startAngle + angleStep * i;
				s.graphics.lineTo(center_x+radius*Math.cos(angle),center_y-radius*Math.sin(angle));
			}
			s.graphics.lineTo(center_x,center_y);
		}

		
		private function updateMask(radius:Number):void{
			if(subType == "7"){
				arcAngle = tweenObj.angle;
				var centerX1:Number = TransitionManager.transitionAreaWidth / 4;
				var centerY1:Number = TransitionManager.transitionAreaHeight / 2;
				var centerX2:Number = 3 * TransitionManager.transitionAreaWidth / 4;
				var centerY2:Number = TransitionManager.transitionAreaHeight / 2;
				
				//var clockwise:Number = (subType == "1") ? -1 : 1;
				
				var grid1:Bitmap = current.parent.getChildByName("grid1") as Bitmap;
				var curMask1:Shape = grid1.mask as Shape;
				curMask1.graphics.clear();
				curMask1.graphics.beginFill(0x000000,1);
				draw_arc(curMask1,centerX1,centerY1,radius,0,arcAngle);
				curMask1.graphics.endFill();
				
				var grid2:Bitmap = current.parent.getChildByName("grid2") as Bitmap;
				var curMask2:Shape = grid2.mask as Shape;
				curMask2.graphics.clear();
				curMask2.graphics.beginFill(0x000000,1);
				draw_arc(curMask2,centerX2,centerY2,radius,Math.PI,-1*arcAngle);
				curMask2.graphics.endFill();
				
				
			}else{
				var curMask:Shape = current.mask as Shape;
				curMask.graphics.clear();
				if(subType == "1" || subType == "2"){
					if(tweenObj.angle > tweenObj.count * 2*Math.PI){
						tweenObj.count += 1;
					}
					var alpha:Number = tweenObj.count / amount;
					var arcAngle:Number = tweenObj.angle - (tweenObj.count - 1) * (2*Math.PI);
					var centerX:Number = TransitionManager.transitionAreaWidth / 2;
					var centerY:Number = TransitionManager.transitionAreaHeight / 2;
					
					var clockwise:Number = (subType == "1") ? -1 : 1;
					
					curMask.graphics.beginFill(0x000000,alpha);
					draw_arc(curMask,centerX,centerY,radius,Math.PI/2,clockwise*arcAngle);
					curMask.graphics.endFill();
					curMask.graphics.beginFill(0x000000,(tweenObj.count - 1) / amount);
					draw_arc(curMask,centerX,centerY,radius,Math.PI / 2 + clockwise * arcAngle,clockwise * (2*Math.PI - arcAngle));
					curMask.graphics.endFill();
	
				}else if(subType == "3" || subType == "4"){
					if(tweenObj.angle >= tweenObj.count * (Math.PI / 2)){
						tweenObj.count += 1;
					}
					alpha = tweenObj.count / amount;
					arcAngle = tweenObj.angle - (tweenObj.count - 1) * (Math.PI / 2);
					
					clockwise = (subType == "3") ? -1 : 1;
					centerX = TransitionManager.transitionAreaWidth / 2;
					centerY = (subType == "3") ? TransitionManager.transitionAreaHeight : 0;
					
					curMask.graphics.beginFill(0x000000,alpha);
					draw_arc(curMask,centerX,centerY,radius,Math.PI,clockwise*arcAngle);
					curMask.graphics.endFill();
					
					curMask.graphics.beginFill(0x000000,alpha);
					draw_arc(curMask,centerX,centerY,radius,0,-1 * clockwise * arcAngle);
					curMask.graphics.endFill();
					
					curMask.graphics.beginFill(0x000000,(tweenObj.count - 1) / amount);
					if(subType == "3"){
						draw_arc(curMask,centerX,centerY,radius,arcAngle,(Math.PI - 2 * arcAngle));
					}else{
						draw_arc(curMask,centerX,centerY,radius,Math.PI+arcAngle,(Math.PI - 2 * arcAngle));
					}
					
					curMask.graphics.endFill();
				}else if(subType == "5" || subType == "6"){
					if(tweenObj.angle >= tweenObj.count * (Math.PI / 2)){
						tweenObj.count += 1;
					}
					alpha = tweenObj.count / amount;
					arcAngle = tweenObj.angle - (tweenObj.count - 1) * (Math.PI / 2);
					
					clockwise = (subType == "5") ? -1 : 1;
					centerX = (subType == "5") ? 0 : TransitionManager.transitionAreaWidth;
					centerY = TransitionManager.transitionAreaHeight /2;
					
					curMask.graphics.beginFill(0x000000,alpha);
					draw_arc(curMask,centerX,centerY,radius,Math.PI/2,clockwise*arcAngle);
					curMask.graphics.endFill();
					
					curMask.graphics.beginFill(0x000000,alpha);
					draw_arc(curMask,centerX,centerY,radius,3*Math.PI/2,-1 * clockwise * arcAngle);
					curMask.graphics.endFill();
					
					curMask.graphics.beginFill(0x000000,(tweenObj.count - 1) / amount);
					draw_arc(curMask,centerX,centerY,radius,Math.PI/2+clockwise*arcAngle,clockwise * (Math.PI - 2 * arcAngle));
					curMask.graphics.endFill();
				}
			}
			
			
		}
		private function transitionCompleted():void {
			if(subType == "7"){
				var grid1:Bitmap = current.parent.getChildByName("grid1") as Bitmap;
				current.parent.removeChild(grid1.mask);
				grid1.bitmapData.dispose();
				current.parent.removeChild(grid1);
				var grid2:Bitmap = current.parent.getChildByName("grid2") as Bitmap;
				current.parent.removeChild(grid2.mask);
				grid2.bitmapData.dispose();
				current.parent.removeChild(grid2);
				current.visible = true;
			}else{
				current.removeChild(current.mask);
				current.mask = null;
			}
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(tweenObj);
			transitionCompleted();
		}
					
	}
}