﻿package transitions 
{
	import caurina.transitions.Tweener;
	
	import flash.display.GradientType;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Matrix;

	public class MultiRevealTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		public function MultiRevealTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.LEFT,time:Number=1,startAlpha:Number=1) 
		{
			this.current = current;
			this.old = old;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			var curMask:Shape = new Shape();
			curMask.graphics.lineStyle(0, 0, 0);
			curMask.graphics.beginFill(0x000000, 1);
			
			if (direction == TransitionManager.RIGHT) {
				curMask.graphics.drawRect( 0, 0, TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( TransitionManager.transitionAreaWidth + 2, 0, 10, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( TransitionManager.transitionAreaWidth + 14, 0, 2, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( TransitionManager.transitionAreaWidth + 18, 0, 2, TransitionManager.transitionAreaHeight);
			}else if (direction == TransitionManager.LEFT) {
				curMask.graphics.drawRect( 0, 0, 2, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( 4, 0, 2, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( 8, 0, 10, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( 20, 0, TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight);
			}else if (direction == TransitionManager.DOWN) {
				curMask.graphics.drawRect( 0, 0, TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight);
				curMask.graphics.drawRect( 0, TransitionManager.transitionAreaHeight + 2, TransitionManager.transitionAreaWidth, 10);
				curMask.graphics.drawRect( 0, TransitionManager.transitionAreaHeight + 14, TransitionManager.transitionAreaWidth, 2);
				curMask.graphics.drawRect( 0, TransitionManager.transitionAreaHeight + 18, TransitionManager.transitionAreaWidth, 2);
			}else if (direction == TransitionManager.UP) {
				curMask.graphics.drawRect( 0, 0, TransitionManager.transitionAreaWidth, 2);
				curMask.graphics.drawRect( 0, 4, TransitionManager.transitionAreaWidth, 2);
				curMask.graphics.drawRect( 0, 8, TransitionManager.transitionAreaWidth, 10);
				curMask.graphics.drawRect( 0, 20, TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight);
				
			}
			
			curMask.graphics.endFill();

			current.addChild(curMask);
			curMask.cacheAsBitmap = true;
			current.mask = curMask;
			current.alpha = startAlpha;
			
			
			if(direction==TransitionManager.UP){
				curMask.y = curMask.height;
				Tweener.addTween(curMask, { y:-20, time:time, transition:"linear"  } );
			}else if (direction == TransitionManager.DOWN) {
				curMask.y = -curMask.height;
				Tweener.addTween(curMask, { y:0, time:time,transition:"linear"  } );
			}else if(direction==TransitionManager.RIGHT){
				curMask.x = -curMask.width;
				Tweener.addTween(curMask, { x:0, time:time,transition:"linear"  } );
			}else if(direction==TransitionManager.LEFT){
				curMask.x = curMask.width;
				Tweener.addTween(curMask, { x:-20, time:time,transition:"linear"  } );
			}
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			current.alpha = 1;
			
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			Tweener.removeTweens(current.mask);
			
			if (old) {
				Tweener.removeTweens(old);
			}
			transitionCompleted();
		}
			
		
	}
	
}