﻿package transitions 
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	Some code has been taken and modified from http://www.reflektions.com/miniml/template_permalink.asp?id=390
	
	$(CBI)*/
	public class PixelatedTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var direction:String;
		private var size:Number;
		private var time:Number;
		private var pixSprite:Sprite;
		private var bitmap:Bitmap;
		private var bitmapData:BitmapData;
		private var bitmapEffect:BitmapData;
		private var tweenObj:Object;
		private var initx:Number;
		private var inity:Number;
		
		public function PixelatedTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.NONE,size:Number=40,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			this.direction = direction;
			this.size = size;
			this.time = time;
			
			
			tweenObj = new Object();
			tweenObj.size = size;
			if(direction!=TransitionManager.NONE){
				if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
					current.parent.swapChildren(current, old);
				
				bitmapData = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight,true,0x00000000);
				bitmapData.draw(current);
				
				current.visible = false;
				bitmapEffect = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight, true, 0x00000000);
				bitmap = new Bitmap(bitmapEffect, "auto", true);
				current.parent.addChild(bitmap);
				
				
				var mask:Sprite = new Sprite();
				mask.graphics.lineStyle(0, 0, 0);
				mask.graphics.beginFill(0x000000,0);
				mask.graphics.drawRect(0, 0, TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight);
				mask.graphics.endFill();
				current.parent.addChild(mask);
				bitmap.mask = mask;
				if(direction == TransitionManager.RIGHT){
					mask.width = 0;
					initx = 0;
					tweenObj.x = initx;
					Tweener.addTween(tweenObj, { x:initx + bitmap.width,size:3, time:time,onUpdate:render,onComplete:transitionCompleted,transition:"easeOutQuad" } );
				}else if(direction == TransitionManager.LEFT){
					mask.width = 0;
					initx = TransitionManager.transitionAreaWidth;
					tweenObj.x = initx;
					Tweener.addTween(tweenObj, { x:initx - bitmap.width,size:3, time:time,onUpdate:render,onComplete:transitionCompleted,transition:"easeOutQuad" } );
				}else if(direction == TransitionManager.UP){
					mask.height = 0;
					inity = TransitionManager.transitionAreaHeight;
					tweenObj.y = inity;
					Tweener.addTween(tweenObj, { y:inity - bitmap.height,size:3, time:time,onUpdate:render,onComplete:transitionCompleted,transition:"easeOutQuad" } );
				}else if(direction == TransitionManager.DOWN){
					mask.height = 0;
					inity = 0;
					tweenObj.y = inity;
					Tweener.addTween(tweenObj, { y:inity + bitmap.height,size:3, time:time,onUpdate:render,onComplete:transitionCompleted,transition:"easeOutQuad" } );
				}
			}else{
				if(old){
					if(current.parent.getChildIndex(current)>current.parent.getChildIndex(old))
					current.parent.swapChildren(current, old);
				
					bitmapData = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight,true,0x00000000);
					bitmapData.draw(old);
				
					
					
					bitmapEffect = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight, true, 0x00000000);
					bitmap = new Bitmap(bitmapEffect, "auto", true);
					current.parent.addChild(bitmap);
					current.visible = false;
					
					tweenObj.size = 3;
					Tweener.addTween(tweenObj, { size:size, time:time/2,onUpdate:renderNone,onComplete:renderOutCompleted,transition:"easeInQuad" } );
				}
				else{
					renderIn(time);
				}
				
			}

			
		}
		private function renderNone():void{
			for (var posX:Number = 0; posX < TransitionManager.transitionAreaWidth; posX += tweenObj.size) {
				for (var posY:Number = 0; posY < TransitionManager.transitionAreaHeight; posY += tweenObj.size) {
					var color:uint = bitmapData.getPixel32(posX, posY);
					var square:Rectangle = new Rectangle(posX, posY, tweenObj.size, tweenObj.size);
					bitmapEffect.fillRect(square, color);
				}
			}
		}
		private function renderIn(time:Number):void{
			bitmapData = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight,true,0x00000000);
			bitmapData.draw(current);
			
			current.visible = false;
			bitmapEffect = new BitmapData(current.width, current.height, true, 0x00000000);
			bitmap = new Bitmap(bitmapEffect, "auto", true);
			current.parent.addChild(bitmap);
			
			tweenObj.size = size;
			renderNone();
			Tweener.addTween(tweenObj, { size:3, time:time,onUpdate:renderNone,onComplete:transitionCompleted,transition:"easeOutQuad" } );
		}
		private function renderOutCompleted():void{
			bitmap.bitmapData.dispose();
			current.parent.removeChild(bitmap);
			renderIn(time/2);
		}
		private function render():void {
			if(direction == TransitionManager.RIGHT){
				var pos:Number = tweenObj.x - initx;
				for (var posX:Number = 0; posX < pos; posX += tweenObj.size) {
					for (var posY:Number = 0; posY < TransitionManager.transitionAreaHeight; posY += tweenObj.size) {
						var color:uint = bitmapData.getPixel32(posX, posY);
						var square:Rectangle = new Rectangle(posX, posY, tweenObj.size, tweenObj.size);
						bitmapEffect.fillRect(square, color);
					}
				}
				bitmap.mask.width = pos;
			}else if(direction == TransitionManager.LEFT){
				pos = initx;
				for (posX = tweenObj.x; posX < pos; posX += tweenObj.size) {
					for (posY = 0; posY < TransitionManager.transitionAreaHeight; posY += tweenObj.size) {
						color = bitmapData.getPixel32(posX, posY);
						square = new Rectangle(posX, posY, tweenObj.size, tweenObj.size);
						bitmapEffect.fillRect(square, color);
					}
				}
				bitmap.mask.x = tweenObj.x;
				bitmap.mask.width = initx - tweenObj.x;
			}else if(direction == TransitionManager.UP){
				pos = inity;
				for (posY = tweenObj.y; posY < pos; posY += tweenObj.size) {
					for (posX = 0; posX < TransitionManager.transitionAreaWidth; posX += tweenObj.size) {
						color = bitmapData.getPixel32(posX, posY);
						square = new Rectangle(posX, posY, tweenObj.size, tweenObj.size);
						bitmapEffect.fillRect(square, color);
					}
				}
				bitmap.mask.y = tweenObj.y;
				bitmap.mask.height = inity - tweenObj.y;
			}else if(direction == TransitionManager.DOWN){
				pos = tweenObj.y - inity;
				for (posY = 0; posY < pos; posY += tweenObj.size) {
					for (posX = 0; posX < TransitionManager.transitionAreaWidth; posX += tweenObj.size) {
						color = bitmapData.getPixel32(posX, posY);
						square = new Rectangle(posX, posY, tweenObj.size, tweenObj.size);
						bitmapEffect.fillRect(square, color);
					}
				}
				bitmap.mask.height = pos;
			}

		}
		private function transitionCompleted():void {
			current.alpha = 1;
			if(bitmap.mask&&current.parent.contains(bitmap.mask)){
				current.parent.removeChild(bitmap.mask);
				bitmap.mask = null;
			}
			if (old) {
				old.visible = false;
			}
			current.visible = true;
			current.parent.removeChild(bitmap);
			bitmap.bitmapData.dispose();
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(tweenObj);
			transitionCompleted();
		}
		
	}
	
}