package transitions
{
	import caurina.transitions.Tweener;
	
	import flash.display.Shape;
	import flash.display.Sprite;

	public class RandomRectanglesTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var type:String;
		private var rowAmount:Number;
		private var colAmount:Number;
		private var d:Number;
		private var delayOrder:Array;
		private var gWidth:Number;
		private var gHeight:Number;
		private var grids:Array;
		private var maskSprite:Sprite;
		public function RandomRectanglesTransition(current:Sprite,old:Sprite,rowAmount:Number=10,colAmount:Number = 10,effect:Number =1,time:Number=1,startAlpha:Number = 0) 
		{
			this.current = current;
			this.old = old;
			this.rowAmount = rowAmount;
			this.colAmount = colAmount;
			grids = new Array();
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			d = time / (rowAmount*colAmount-1)
			if(effect == 1){
				d = time / (rowAmount*colAmount+7);
			}
			createDelayOrder();
			
			
			gWidth = Math.floor(TransitionManager.transitionAreaWidth/colAmount);
			gHeight = Math.floor(TransitionManager.transitionAreaHeight/rowAmount);
			
			var remainingWidth:Number = TransitionManager.transitionAreaWidth - gWidth*colAmount;
			var remainingHeight:Number = TransitionManager.transitionAreaHeight - gHeight*rowAmount;
			
			maskSprite = new Sprite();
			current.addChild(maskSprite);
			maskSprite.cacheAsBitmap = true;
			current.mask = maskSprite;
			for(var i:int = 0;i<colAmount;i++){
				for(var j:int = 0;j<rowAmount;j++){
					var w:Number = gWidth;
					var h:Number = gHeight;
					if(i==colAmount-1){
						w += remainingWidth;
					}
					if(j==rowAmount-1){
						h += remainingHeight;
					}
					var gridShape:Shape = new Shape();
					gridShape.graphics.beginFill(0x000000);
					gridShape.graphics.drawRect(w/-2,h/-2,w,h);
					gridShape.graphics.endFill();
					var grid:Sprite = new Sprite();
					grid.addChild(gridShape);
					grid.x = i*gWidth + w/2;
					grid.y = j*gHeight + h/2;
					grid.scaleX = 0;
					grid.scaleY = 0;
					grid.alpha = startAlpha;
					maskSprite.addChild(grid);
					grids.push(grid);
					var di:Number = i*rowAmount+j;
					var t:Number = 0.01;
					if(effect == 1){
						t = 8 * d;
					}
					if(delayOrder[di] == (rowAmount*colAmount-1) * d){
						Tweener.addTween(grid,{scaleX:1,scaleY:1,alpha:1,delay:delayOrder[di],time:t,onComplete:transitionCompleted,transition:"linear"});
					}else{
						Tweener.addTween(grid,{scaleX:1,scaleY:1,alpha:1,delay:delayOrder[di],time:t,transition:"linear"});
					}
					
				}
			}
			
		}
		private function createDelayOrder():void {
			
			delayOrder = new Array(rowAmount*colAmount);
			for(var i:uint=0;i<rowAmount*colAmount;i++){
				delayOrder[i]=i*d;
			}
			for(i=0;i<rowAmount*colAmount*2;i++){
				var a:Number = Math.floor(Math.random()*rowAmount*colAmount);
				var b:Number = Math.floor(Math.random()*rowAmount*colAmount);
				var t:Number = delayOrder[a];
				delayOrder[a] = delayOrder[b];
				delayOrder[b] = t;
			}
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			for(var i:int = 0;i<grids.length;i++)
				Tweener.removeTweens(grids[i]);
			transitionCompleted();
		}
	}
}