﻿package transitions 
{
	import caurina.transitions.Tweener;
	
	import flash.display.GradientType;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Matrix;

	public class RevealTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		public function RevealTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.LEFT,effect:Number=0,time:Number=1,startAlpha:Number=1) 
		{
			
			this.current = current;
			this.old = old;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			var curMask:Shape = new Shape();
			curMask.graphics.lineStyle(0, 0, 0);
			

			
			if (effect == 1) {
				var matrix:Matrix = new Matrix();
				if (direction == TransitionManager.UP) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight,-Math.PI/2, 0, 0);
				}else if (direction == TransitionManager.DOWN) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, Math.PI/2, 0, 0);
				}else if (direction == TransitionManager.LEFT) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, Math.PI, 0, 0);
				}else if (direction == TransitionManager.RIGHT) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, 0, 0, 0);
				}else if (direction == TransitionManager.UPLEFT) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, -3*Math.PI / 4, 0, 0);
				}else if (direction == TransitionManager.DOWNLEFT) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, 3 * Math.PI / 4, 0, -TransitionManager.transitionAreaHeight);
				}else if (direction == TransitionManager.UPRIGHT) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, - Math.PI / 4, 0, TransitionManager.transitionAreaHeight);
				}else if (direction == TransitionManager.DOWNRIGHT) {
					matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, Math.PI / 4, 0, 0);
				}
				curMask.graphics.beginGradientFill(GradientType.LINEAR, [0x000000, 0x000000], [1, 0], [235, 255], matrix);
			}else{
				curMask.graphics.beginFill(0x000000, 1);
			}
			//curMask.graphics.beginFill(0, 0);
			if (direction == TransitionManager.UPRIGHT) {
				curMask.graphics.moveTo(0,0);
				curMask.graphics.lineTo(2.4*TransitionManager.transitionAreaWidth,2.4*TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(0,2.4*TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(0,0);
			}else if (direction == TransitionManager.DOWNLEFT) {				
				curMask.graphics.moveTo( 0,0);
				curMask.graphics.lineTo(2.4*TransitionManager.transitionAreaWidth,0);
				curMask.graphics.lineTo(2.4*TransitionManager.transitionAreaWidth,2.4*TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo( 0,0);
			}else if (direction == TransitionManager.DOWNRIGHT) {
				curMask.graphics.moveTo(0,0);
				curMask.graphics.lineTo(2.4*TransitionManager.transitionAreaWidth,0);
				curMask.graphics.lineTo(0,2.4*TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(0,0);
			}else if (direction == TransitionManager.UPLEFT) {
				curMask.graphics.moveTo(0,0);
				curMask.graphics.lineTo(0,2.4*TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(-2.4*TransitionManager.transitionAreaWidth,2.4*TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(0,0);
			}else{
				curMask.graphics.drawRect( 0, 0, TransitionManager.transitionAreaWidth*1.2, TransitionManager.transitionAreaHeight*1.2);
			}
			curMask.graphics.endFill();

			current.addChild(curMask);
			curMask.cacheAsBitmap = true;
			current.mask = curMask;
			current.alpha = startAlpha;
			
			if(direction==TransitionManager.UP){
				curMask.y = TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, { y:-0.2*TransitionManager.transitionAreaHeight, time:time, transition:"linear"  } );
			}else if (direction == TransitionManager.DOWN) {
				curMask.y = -1.2 * TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, { y:0, time:time,transition:"linear"  } );
			}else if(direction==TransitionManager.RIGHT){
				curMask.x = -1.2 * TransitionManager.transitionAreaWidth;
				Tweener.addTween(curMask, { x:0, time:time,transition:"linear"  } );
			}else if(direction==TransitionManager.LEFT){
				curMask.x = TransitionManager.transitionAreaWidth;
				Tweener.addTween(curMask, { x:-0.2*TransitionManager.transitionAreaWidth, time:time,transition:"linear"  } );
			}else if(direction==TransitionManager.UPRIGHT){
				curMask.x = -1.2 * TransitionManager.transitionAreaWidth;
				curMask.y = -0.2 * TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, { x:0,y:-1.4*TransitionManager.transitionAreaHeight, time:time,transition:"linear" } );
			}else if(direction==TransitionManager.DOWNLEFT){
				curMask.x = -0.2 * TransitionManager.transitionAreaWidth;
				curMask.y = -1.2 * TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, { x:-1.4 * TransitionManager.transitionAreaWidth,y:0, time:time,transition:"linear" } );
			}else if(direction==TransitionManager.DOWNRIGHT){
				curMask.x = -1.2 * TransitionManager.transitionAreaWidth;
				curMask.y = -1.2 * TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, { x:0,y:0, time:time,transition:"linear" } );
			}else if(direction==TransitionManager.UPLEFT){
				curMask.x = 2.2 * TransitionManager.transitionAreaWidth;
				curMask.y = -0.2*TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, {x:TransitionManager.transitionAreaWidth, y:-1.4*TransitionManager.transitionAreaHeight, time:time,transition:"linear" } );
			}
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			current.alpha = 1;
			
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			Tweener.removeTweens(current.mask);
			
			if (old) {
				Tweener.removeTweens(old);
			}
			transitionCompleted();
		}
		
	}
	
}