package transitions
{
	import caurina.transitions.Tweener;
	
	import flash.display.Sprite;

	public class RollTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var oldHolder:Sprite;
		private var oldProp:Object;
		public function RollTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.UPRIGHT,time:Number=1,startAlpha:Number = 1) {
			this.current = current;
			this.old = old;
			if(current.parent.getChildIndex(current)>current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			current.alpha = startAlpha;
			
			oldProp = new Object();
			oldProp.x = old.x;
			oldProp.y = old.y;
			oldProp.parent = old.parent;
			
			old.parent.removeChild(old);
			oldHolder = new Sprite();
			oldHolder.addChild(old);
			oldProp.parent.addChild(oldHolder);
			
				
			if(direction==TransitionManager.UPRIGHT){
				old.x -= TransitionManager.transitionAreaWidth;
				old.y -= TransitionManager.transitionAreaHeight;
				oldHolder.x = oldProp.x + TransitionManager.transitionAreaWidth;
				oldHolder.y = oldProp.y + TransitionManager.transitionAreaHeight;
				Tweener.addTween(oldHolder, { rotation:90, time:time, transition:"linear" } );
			}else if(direction==TransitionManager.UPLEFT){
				old.y -= TransitionManager.transitionAreaHeight;
				oldHolder.y = oldProp.y + TransitionManager.transitionAreaHeight;
				Tweener.addTween(oldHolder, { rotation:-90, time:time, transition:"linear" } );
			}else if(direction==TransitionManager.DOWNLEFT){
				Tweener.addTween(oldHolder, { rotation:90, time:time, transition:"linear" } );
			}else if(direction==TransitionManager.DOWNRIGHT){
				old.x -= TransitionManager.transitionAreaWidth;
				oldHolder.x = oldProp.x + TransitionManager.transitionAreaWidth;
				Tweener.addTween(oldHolder, { rotation:-90, time:time, transition:"linear" } );
			}
			

			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
		}
		private function transitionCompleted():void {
			if (oldProp) {
				oldHolder.removeChild(old);
				oldHolder.parent.removeChild(oldHolder);
				old.x = oldProp.x;
				old.y = oldProp.y;	
				oldProp.parent.addChild(old);
			}
			current.alpha = 1;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(oldHolder);
			Tweener.removeTweens(current);
			transitionCompleted();
		}
	
	}
}