﻿package transitions 
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Matrix;

	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class SplitTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		public function SplitTransition(current:Sprite,old:Sprite,subtype:String=TransitionManager.HORIZONTAL,direction:String = TransitionManager.OUT,effect:Number = 0,time:Number=1,startAlpha:Number=1) 
		{
			this.current = current;
			this.old = old;
			if (!old) {
				return;
			}
			current.alpha = startAlpha;
			if (direction == TransitionManager.OUT) {
				if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
					current.parent.swapChildren(current, old);
				
				
				var curMask:Shape = new Shape();
				curMask.graphics.lineStyle(0, 0, 0);
			

			
				if (effect == 1) {
					
					var matrix:Matrix = new Matrix();
					if (subtype == TransitionManager.HORIZONTAL) {
						matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight,0, 0, 0);
					}else if (subtype == TransitionManager.VERTICAL) {
						matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, Math.PI/2, 0, 0);
					}
					curMask.graphics.beginGradientFill(GradientType.LINEAR, [0x000000, 0x000000,0x000000,0x000000], [0, 1,1, 0], [1,20,235, 255], matrix);
				}else{
					curMask.graphics.beginFill(0x000000, 1);
				}
				curMask.graphics.drawRect( 0, 0, 1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight);
				curMask.graphics.endFill();
				
				current.addChild(curMask);
				curMask.cacheAsBitmap = true;
				current.mask = curMask;
				
				
				if (subtype == TransitionManager.HORIZONTAL) {
					curMask.x = TransitionManager.transitionAreaWidth / 2;
					curMask.scaleX = 0;
					Tweener.addTween(curMask, { x: -0.1 * TransitionManager.transitionAreaWidth, scaleX:1, time:time, transition:"linear" } );
				}else if (subtype == TransitionManager.VERTICAL) {
					curMask.y = TransitionManager.transitionAreaHeight / 2;
					curMask.scaleY = 0;
					Tweener.addTween(curMask, { y: -0.1 * TransitionManager.transitionAreaHeight, scaleY:1, time:time, transition:"linear" } );
				}
				
				
			}else if (direction == TransitionManager.IN) {
				if(old&&current.parent.getChildIndex(current)>current.parent.getChildIndex(old))
					current.parent.swapChildren(current, old);
				
				
				var oldMask:Shape = new Shape();
				oldMask.graphics.lineStyle(0, 0, 0);
			

			
				if (effect == 1) {
					
					matrix = new Matrix();
					if (subtype == TransitionManager.HORIZONTAL) {
						matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight,0, 0, 0);
					}else if (subtype == TransitionManager.VERTICAL) {
						matrix.createGradientBox(1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight, Math.PI/2, 0, 0);
					}
					oldMask.graphics.beginGradientFill(GradientType.LINEAR, [0x000000, 0x000000,0x000000,0x000000], [0, 1,1, 0], [1,20,235, 255], matrix);
				}else{
					oldMask.graphics.beginFill(0x000000, 1);
				}
				oldMask.graphics.drawRect( 0, 0, 1.2*TransitionManager.transitionAreaWidth, 1.2*TransitionManager.transitionAreaHeight);
				oldMask.graphics.endFill();
				
				old.addChild(oldMask);
				oldMask.cacheAsBitmap = true;
				old.mask = oldMask;
				
				
				if (subtype == TransitionManager.HORIZONTAL) {
					oldMask.x = -0.1 * TransitionManager.transitionAreaWidth;
					Tweener.addTween(oldMask, { x: TransitionManager.transitionAreaWidth / 2, scaleX:0, time:time, transition:"linear" } );
				}else if (subtype == TransitionManager.VERTICAL) {
					oldMask.y = -0.1 * TransitionManager.transitionAreaHeight;
					Tweener.addTween(oldMask, { y:TransitionManager.transitionAreaHeight / 2 , scaleY:0, time:time, transition:"linear" } );
				}
				
				
			}
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
		}
		private function transitionCompleted():void {
			if(current.mask){
				current.removeChild(current.mask);
				current.mask = null;
			}
			if(old.mask){
				old.removeChild(old.mask);
				old.mask = null;
			}
			current.alpha = 1;
			
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			Tweener.removeTweens(current.mask);
			Tweener.removeTweens(old.mask);
			if (old) {
				Tweener.removeTweens(old);
			}
			transitionCompleted();
		}
		
	}
	
}