package transitions
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;

	public class StaticTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var staticBitmap:Bitmap;
		private var staticData:BitmapData;
		public function StaticTransition(current:Sprite,old:Sprite,smooth:Number=1,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			//this.current.alpha = 0;
			
			staticData = new BitmapData(TransitionManager.transitionAreaWidth/smooth,TransitionManager.transitionAreaHeight/smooth);
			staticBitmap = new Bitmap(staticData);
			staticData.noise(int(Math.random() * int.MAX_VALUE),0, 0xFFFFFF, 0, true);
			staticBitmap.scaleX = staticBitmap.scaleY = smooth;
			current.addChild(staticBitmap);
			if(old&&current.parent.getChildIndex(current)>current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			Tweener.addTween(old, { alpha:0, time:time/2, transition:"linear",onUpdate:updateStatic } );
			Tweener.addTween(staticBitmap, { alpha:0,delay:time / 2, time:time/2,transition:"linear" ,onUpdate:updateStatic, onComplete:transitionCompleted } );
		}
		private function updateStatic():void{
			staticData.noise(int(Math.random() * int.MAX_VALUE),0, 0xFFFFFF, 0, true);
		}
		private function transitionCompleted():void {
			current.removeChild(staticBitmap);
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(old);
			Tweener.removeTweens(staticBitmap);
			transitionCompleted();
		}
	}
}