﻿package transitions 
{	
	import caurina.transitions.Tweener;
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;

	public class StretchTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		private var currentProp:Object;
		public function StretchTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.LEFT,time:Number=1,startAlpha:Number=1) 
		{	
			this.current = current;
			this.old = old;
			current.alpha = startAlpha;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
						
			currentProp = new Object();
			currentProp.x = current.x;
			currentProp.y = current.y;
			currentProp.scaleX = current.scaleX;
			currentProp.scaleY = current.scaleY;

			if (direction == TransitionManager.LEFT) {
				current.x = current.x + TransitionManager.transitionAreaWidth;
				current.scaleX = 0;
				Tweener.addTween(current, { x:currentProp.x,scaleX:currentProp.scaleX, alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}
			else if (direction == TransitionManager.RIGHT) {
				current.scaleX = 0;
				Tweener.addTween(current, { scaleX:currentProp.scaleX, alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}else if (direction == TransitionManager.UP) {
				current.y = current.y + TransitionManager.transitionAreaHeight;
				current.scaleY = 0;
				Tweener.addTween(current, { y:currentProp.y,scaleY:currentProp.scaleY, alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}
			else if (direction == TransitionManager.DOWN) {
				current.scaleY = 0;
				Tweener.addTween(current, {scaleY:currentProp.scaleY, alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}else if (direction == TransitionManager.LEFTRIGHT) {
				current.x = current.x + TransitionManager.transitionAreaWidth / 2; 
				current.scaleX = 0;
				Tweener.addTween(current, {x:currentProp.x,scaleX:currentProp.scaleX, alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}else if (direction == TransitionManager.UPDOWN) {
				current.y = current.y + TransitionManager.transitionAreaHeight / 2; 
				current.scaleY = 0;
				Tweener.addTween(current, {y:currentProp.y,scaleY:currentProp.scaleY, alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}else if (direction == TransitionManager.CENTER) {
				current.x = current.x + TransitionManager.transitionAreaWidth / 2; 
				current.y = current.y + TransitionManager.transitionAreaHeight / 2; 
				current.scaleX = 0;
				current.scaleY = 0;
				Tweener.addTween(current, {x:currentProp.x,scaleX:currentProp.scaleX,y:currentProp.y,scaleY:currentProp.scaleY, 
											alpha:1, time:time, transition:"linear",onComplete:transitionCompleted } );
			}
			
		}
		private function transitionCompleted():void {
			
			if (currentProp) {				
				current.x = currentProp.x;
				current.y = currentProp.y;
				current.scaleX = currentProp.scaleX;
				current.scaleY = currentProp.scaleY;
			}
			current.alpha = 1;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			transitionCompleted();
		}
	}
	
}