package transitions
{
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.CurveModifiers;
	import caurina.transitions.properties.FilterShortcuts;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;

	public class SweepTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var gWidth:Number;
		private var gHeight:Number;
		private var grids:Array;
		private var bitmapData:BitmapData;
		private var blurX:Number;
		private var blurY:Number;
		public function SweepTransition(current:Sprite, old:Sprite,direction:String, rowAmount:Number = 8,colAmount:Number=8,subType:String="1",effect:Number = 1,time:Number = 1) 
		{
			this.current = current;
			this.old = old;
			grids = new Array();
			
			blurX=25;
			blurY=25;
			
			if(old){
				if(current.parent.getChildIndex(current)>current.parent.getChildIndex(old))
					current.parent.swapChildren(current, old);
				
				bitmapData = new BitmapData(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight,true,0x00000000);
				bitmapData.draw(old);
				
				gWidth = Math.floor(TransitionManager.transitionAreaWidth/colAmount);
				gHeight = Math.floor(TransitionManager.transitionAreaHeight/rowAmount);
				
				var remainingWidth:Number = TransitionManager.transitionAreaWidth - gWidth*colAmount;
				var remainingHeight:Number = TransitionManager.transitionAreaHeight - gHeight*rowAmount;
				
				//var startX:Number = old.parent.x;
				//var startY:Number = old.parent.y;
				var startX:Number = 0;
				var startY:Number = 0;
				FilterShortcuts.init();
				
				CurveModifiers.init();
				var delay:Number = time/(rowAmount+5);
				
				old.visible = false;
				for(var i:int = 0;i<rowAmount;i++){
					grids[i] = new Array();
					for(var j:int = 0;j<colAmount;j++){
						var w:Number = gWidth;
						var h:Number = gHeight;
						if(i==rowAmount-1){
							h += remainingHeight;
						}
						if(j==colAmount-1){
							w += remainingWidth;
						}
						var bd:BitmapData = new BitmapData(w, h);
						bd.copyPixels(bitmapData, new Rectangle(j*gWidth, i*gHeight, w, h), new Point(0, 0));
						var grid:Bitmap = new Bitmap(bd,"auto",true);
						grid.x = j*gWidth;
						grid.y = i*gHeight;
						grids[i][j] = grid;
					}
				}

				if(direction == TransitionManager.DOWN){
					if(subType == "1"){
						delay = time/(rowAmount+5);
						for(i = rowAmount-1;i>-1;i--){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY+TransitionManager.transitionAreaHeight+2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*i,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*i,time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "2"){
						delay = time/(colAmount+5);
						for(j = 0;j<colAmount;j++){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY+TransitionManager.transitionAreaHeight+2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/2,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*j,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*j,time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "3"){
						delay = time/(colAmount+5);
						for(j = colAmount-1;j>-1;j--){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY+TransitionManager.transitionAreaHeight+2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/2,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(colAmount-j-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(colAmount-j-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "4"){
						delay = time/(rowAmount+5);
						for(i = 0;i<rowAmount;i++){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY+TransitionManager.transitionAreaHeight+2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(rowAmount-i-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(rowAmount-i-1),time:10*delay,transition:"linear"});
							}
						}
					}
				}else if(direction == TransitionManager.RIGHT){
					if(subType == "1"){
						delay = time/(rowAmount+5);
						for(i = 0;i<rowAmount;i++){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth+2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(rowAmount-i-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(rowAmount-i-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "2"){
						delay = time/(colAmount+5);
						for(j = 0;j<colAmount;j++){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth+2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*j,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*j,time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "3"){
						delay = time/(colAmount+5);
						for(j = colAmount-1;j>-1;j--){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth+2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(colAmount-j-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(colAmount-j-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "4"){
						delay = time/(rowAmount+5);
						for(i = rowAmount-1;i>-1;i--){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth+2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*i,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*i,time:10*delay,transition:"linear"});
							}
						}
					}
				}else if(direction == TransitionManager.LEFT){
					if(subType == "1"){
						delay = time/(rowAmount+5);
						for(i = 0;i<rowAmount;i++){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX-2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(rowAmount-i-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(rowAmount-i-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "2"){
						delay = time/(colAmount+5);
						for(j = 0;j<colAmount;j++){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX-2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*j,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*j,time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "3"){
						delay = time/(colAmount+5);
						for(j = colAmount-1;j>-1;j--){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX-2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(colAmount-j-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(colAmount-j-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "4"){
						delay = time/(rowAmount+5);
						for(i = rowAmount-1;i>-1;i--){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX-2*gWidth,y:startY+TransitionManager.transitionAreaHeight/2,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*i,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*i,time:10*delay,transition:"linear"});
							}
						}
					}
				}else if(direction == TransitionManager.UP){
					if(subType == "1"){
						delay = time/(rowAmount+5);
						for(i = 0;i<rowAmount;i++){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY-2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(rowAmount-i-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(rowAmount-i-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "2"){
						delay = time/(colAmount+5);
						for(j = 0;j<colAmount;j++){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY-2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*j,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*j,time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "3"){
						delay = time/(colAmount+5);
						for(j = colAmount-1;j>-1;j--){
							for(i = 0;i<rowAmount;i++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY-2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*(colAmount-j-1),time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*(colAmount-j-1),time:10*delay,transition:"linear"});
							}
						}
					}else if(subType == "4"){
						delay = time/(rowAmount+5);
						for(i = rowAmount-1;i>-1;i--){
							for(j = 0;j<colAmount;j++){
								old.parent.addChild(grids[i][j]);
								Tweener.addTween(grids[i][j],{rotation:Math.floor(Math.random() * 600) + -300,x:startX+TransitionManager.transitionAreaWidth/2,y:startY-2*gHeight,
									_bezier:{x:startX+TransitionManager.transitionAreaWidth/4,y:startY+TransitionManager.transitionAreaHeight+2*gHeight},
									delay:delay*i,time:10*delay,transition:"easeInOutBack"});
								if(effect == 1)
									Tweener.addTween(grids[i][j],{_Blur_blurX:blurX,_Blur_blurY:blurY,delay: delay*i,time:10*delay,transition:"linear"});
							}
						}
					}
				}
				Tweener.addTween(current, { alpha:1, time:time, transition:"linear", onComplete:transitionCompleted } );
				
			}
			
		}
		private function transitionCompleted():void {
			if(grids.length>0){
				for (var i:int = 0; i < grids.length; i++){
					for(var j:int = 0;j<grids[i].length;j++){
						old.parent.removeChild(grids[i][j]);
					}
				}
			}
			bitmapData.dispose();
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			for(var i:int = 0;i<grids.length;i++){
				for(var j:int = 0;j<grids[i].length;j++){
					Tweener.removeTweens(grids[i][j]);
				}
			}
			Tweener.removeTweens(current);
			transitionCompleted();
		}
	}
}