package transitions
{
	import caurina.transitions.Tweener;
	
	import flash.display.Shape;
	import flash.display.Sprite;

	public class WaveRevealTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		public function WaveRevealTransition(current:Sprite,old:Sprite,direction:String=TransitionManager.LEFT,amount:Number=4,time:Number=1,startAlpha:Number=1) 
		{
			this.current = current;
			this.old = old;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			if(direction==TransitionManager.UP || direction==TransitionManager.DOWN){
				var waveSize:Number = Math.floor(TransitionManager.transitionAreaWidth / amount);
			}else{
				waveSize = Math.floor(TransitionManager.transitionAreaHeight / amount);
			}
			
			var waveDepth:Number = Math.round(waveSize/3);
			var waveAmount:Number = Math.round(2*amount);
			
			var curMask:Shape = new Shape();
			curMask.graphics.beginFill(0x000000);
			if(direction==TransitionManager.UP){
				var waveX:Number =0;
				var waveY:Number = -1*waveDepth;
				var dir:Number = -1 ;
				curMask.graphics.moveTo(waveX,waveY);
				for(var i:int = 0;i<waveAmount;i++){
					curMask.graphics.curveTo(waveX+waveSize/2,waveY+waveDepth*dir,waveX+waveSize,waveY);
					waveX += waveSize;
					dir = -1 * dir;
				}
				curMask.graphics.lineTo(waveX,TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(0,TransitionManager.transitionAreaHeight);
				curMask.graphics.lineTo(0,waveY);
			}else if(direction==TransitionManager.DOWN){
				waveX =0;
				waveY =TransitionManager.transitionAreaHeight+waveDepth;
				dir = 1;
				curMask.graphics.lineTo(waveX,waveY);
				for(i = 0;i<waveAmount;i++){
					curMask.graphics.curveTo(waveX+waveSize/2,waveY+waveDepth*dir,waveX+waveSize,waveY);
					waveX += waveSize;
					dir = -1 * dir;
				}
				curMask.graphics.lineTo(waveX,0);
				curMask.graphics.lineTo(0,0);
			}else if(direction==TransitionManager.RIGHT){
				waveX =TransitionManager.transitionAreaWidth+waveDepth;
				waveY =0;
				dir = 1;
				curMask.graphics.lineTo(waveX,waveY);
				for(i = 0;i<waveAmount;i++){
					curMask.graphics.curveTo(waveX+waveDepth*dir,waveY+waveSize/2,waveX,waveY+waveSize);
					waveY += waveSize;
					dir = -1 * dir;
				}
				curMask.graphics.lineTo(0,waveY);
				curMask.graphics.lineTo(0,0);
			}else if(direction==TransitionManager.LEFT){
				waveX =-1*waveDepth;
				waveY =0;
				dir = -1;
				curMask.graphics.moveTo(waveX,waveY);
				for(i = 0;i<waveAmount;i++){
					curMask.graphics.curveTo(waveX+waveDepth*dir,waveY+waveSize/2,waveX,waveY+waveSize);
					waveY += waveSize;
					dir = -1 * dir;
				}
				curMask.graphics.lineTo(TransitionManager.transitionAreaWidth,waveY);
				curMask.graphics.lineTo(TransitionManager.transitionAreaWidth,0);
				curMask.graphics.lineTo(waveX,0);
			}
			curMask.graphics.endFill();
			current.addChild(curMask);
			curMask.cacheAsBitmap = true;
			current.mask = curMask;
			current.alpha = startAlpha;
			
			if(direction==TransitionManager.UP){
				curMask.y = TransitionManager.transitionAreaHeight;
				Tweener.addTween(curMask, {x:-1*(curMask.width-TransitionManager.transitionAreaWidth), y:0, time:time,transition:"linear" } );
			}else if(direction==TransitionManager.DOWN){
				curMask.y = -1*curMask.height;
				Tweener.addTween(curMask, {x:-1*(curMask.width-TransitionManager.transitionAreaWidth), y:0, time:time,transition:"linear" } );
			}else if(direction==TransitionManager.RIGHT){
				curMask.x = -1*curMask.width;
				Tweener.addTween(curMask, {x:0, y:-1*(curMask.height-TransitionManager.transitionAreaHeight), time:time,transition:"linear" } );
			}else if(direction==TransitionManager.LEFT){
				curMask.x = TransitionManager.transitionAreaWidth;
				Tweener.addTween(curMask, {x:0, y:-1*(curMask.height-TransitionManager.transitionAreaHeight), time:time,transition:"linear" } );
			}
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			current.alpha = 1;
			
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);
			Tweener.removeTweens(current.mask);
			transitionCompleted();
		}
	}
}